

#define MAX_DISPLAY_TYPES 3


extern int tx_graph_scro;
extern int tx_flag;


extern int tx_read_bytes;
extern int txmem_size;
extern int tx_ad_maxamp;
extern int tx_input_mode;
extern int tx_input_fragsize;
extern int tx_output_fragsize;
extern int tx_output_totsamp;
extern int tx_write_bytes;
extern float tx_resamp_ampfac1;
extern float tx_resamp_ampfac2;
extern int *txmem_handle;
extern int tx_audio_in;
extern int tx_audio_out;
extern short int *txtrace;
extern float txad_hz_per_bin;
extern float txtrace_gain;
extern int txtrace_height;
extern float micfft_bin_minpower_ref;
extern float micfft_bin_minpower;
extern float micfft_minpower_ref;
extern float micfft_minpower;
extern float *mic_filter;
extern int *tx_out_int;

extern short int *tx_out_shi;
extern float tx_agc_factor;
extern float tx_agc_decay;
extern float txpwr_decay;
extern float tx_forwardpwr;
extern float tx_backpwr;
extern int tx_output_flag;
extern int tx_ph1;
extern float tx_resample_ratio;
extern float new_tx_resample_ratio;
extern int tx_output_upsample;
extern int tx_resamp_pa;
extern int tx_resamp_px;
extern int tx_filter_ia1;
extern int tx_filter_ia2;
extern int tx_filter_ia3;
extern int tx_filter_ib1;
extern int tx_filter_ib2;
extern int tx_filter_ib3;
extern char display_color[MAX_DISPLAY_TYPES];
extern int tx_pre_resample;
extern int tx_wrblock_no;
extern int tx_output_mode;
extern int tx_show_siz;
extern int tx_wsamps;
extern float tx_wttim;
extern float tx_wttim_sum;
extern float tx_wttim_ref;
extern float tx_wttim_diff;
extern double tx_output_phase;
extern float tx_output_phstep;
extern int tx_setup_flag;

// ***************************************************
//      Transform sizes and associated variables.
//
// ***************************************************
// The first time function, data from the soundcard. The transform
// size is set for the data to span a suitable time in order to
// get a frequency resolution and an associated time delay that
// is independent of the microphone input sampling speed.
// Size is micsize.
extern short int *mictimf_shi;
extern int *mictimf_int;
extern int micsize;
extern int micn;
extern int mictimf_pa;
extern int mictimf_px;
extern int mictimf_block;
extern int mictimf_bufsiz;
extern int mictimf_mask;
extern float *mic_win;
extern COSIN_TABLE *mic_table;
extern unsigned short int *mic_permute;
extern float *mic_tmp;
// ***************************************************
// The first FFT. The transforms are likely to span a far too large
// frequency range. Only the minimum required to represent the passband
// of interest is used for the output of mic_fft     
// Size is mic_fftsize.
extern float *micfft;
extern int mic_fftsize; 
extern int mic_fftn;
extern int mic_fftsize_start;
extern int mic_fftn_start;
extern int mic_sizhalf;
extern int micfft_pa;
extern int micfft_px;
extern int micfft_block;
extern int micfft_bufsiz;
extern int micfft_mask;
extern COSIN_TABLE *micfft_table;
extern unsigned short int *micfft_permute;
extern float *micfft_win;
// ***************************************************
// The second time function. Here we will do clipping.
// Size is mic_fftsize.
extern float *cliptimf;
extern int cliptimf_pa;
extern int cliptimf_px;
// ***************************************************
// The second FFT. Used to clean up the spectrum.
// Size is alc_fftsize.
extern float *clipfft;
extern int clipfft_pa;
extern int clipfft_px;
// ***************************************************
// The third time function. Used for ALC.
// We will use this time function for resampling to a new sampling speed
// that will be equal to the output speed or a power of two faster or
// slower.
// The fractional resampler needs an oversampled input and therefore
// we first upsample by a power of two here.
// Size is alc_fftsize.
extern int alc_fftsize;
extern int alc_fftn;
extern int alc_sizhalf;
extern float *alctimf;
extern float *alctimf_pwrf;
extern float *alctimf_pwrd;
extern int alctimf_pa;
extern int alctimf_pb;
extern float alctimf_fx;
extern int alc_block;
extern int alc_bufsiz;
extern int alc_mask;
extern COSIN_TABLE *alc_table;
extern unsigned short int *alc_permute;
extern float *alc_win;
// ***************************************************
// The fourth time function, the output from the fractional resampler.
// Size is alc_fftsize.
// We use transforms one by one so no buffer pointer is needed.
// The third FFT is computed in place and the size of the transform
// is changed in place to txout_fftsize.
extern float *tx_resamp;
extern float *resamp_tmp;
// ***************************************************
// The fifth time function. 
// Size is txout_fftsize.
extern int txout_fftsize;
extern int txout_fftn;
extern int txout_sizhalf;
extern float *txout;
extern float *txout_tmp;
extern COSIN_TABLE *txout_table;
extern unsigned short int *txout_permute;
// ****************************************************

void show_txfft(float *z, float lim, int type, int siz);
void tx_bar(int xt,int yt,int val1, int val2);
void resample_tx_output(void);
void check_txparms(void);
void init_txmem_spproc(void);
void init_txmem_cwproc(void);
void open_tx_input(void);
void close_tx_input(void);
void spproc_setup(void);
void cwproc_setup(void);
void save_tx_parms(char verbose);
int lir_tx_input_samples(void);
int lir_tx_output_samples(void);
void open_tx_output(void);
void close_tx_output(void);
